//+------------------------------------------------------------------+
//|                                               AR3EURUSDH1aEA.mq4 |
//|                                                          PROFJIM |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "PROFJIM"
#property link      ""

//---- input parameters
extern double    upangle=0.0005;
extern double    dnangle=0.0005;
extern int       LOT=1;
extern int stoploss= 10;
extern int takeprofit= 500;
double SL,TP,cursprd;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   double pips2dbl = Point, pips2points=1;
   bool aheadforup, aheadbkup,aheadfordn, aheadbkdn, buycond, sellcond;
   HideTestIndicators(false);
   double cust=iCustom(NULL,0,"AR3EURUSDH1a",1,0);
   double inita =iCustom(NULL,0,"HPthreePM",0,0);
   if (Digits == 3 || Digits == 5)
      {
   	pips2dbl *= 10.0; 
   	pips2points=1;
      }
//----
   if(iCustom(NULL,0,"AR3EURUSDH1a",300,1,0)>iCustom(NULL,0,"AR3EURUSDH1a",300,1,2)+upangle)
      aheadforup=true;
      else
      aheadforup=false;
   if(iCustom(NULL,0,"AR3EURUSDH1a",300,1,4)>iCustom(NULL,0,"AR3EURUSDH1a",300,1,2)+upangle)
      aheadbkup=true;
      else
      aheadbkup=false;
   buycond=aheadforup==true&&aheadbkup==true;
   if(fANYBUY()==false&&buycond==true) //Buy
   {
      TP  = Ask + takeprofit*pips2points*pips2dbl;
      SL  = Ask - stoploss*pips2points*pips2dbl;     
      CLOSEORDER("Sell");
      OPENORDER ("Buy");
   } 
   if(iCustom(NULL,0,"AR3EURUSDH1a",300,1,0)<iCustom(NULL,0,"AR3EURUSDH1a",300,1,2)-dnangle)
      aheadfordn=true;
      else
      aheadfordn=false;
   if(iCustom(NULL,0,"AR3EURUSDH1a",300,1,4)<iCustom(NULL,0,"AR3EURUSDH1a",300,1,2)-dnangle)
      aheadbkdn=true;
      else
      aheadbkdn=false;
   sellcond=aheadfordn==true&&aheadbkdn==true;
   if (fANYSELL()==false&&sellcond==true) //Sell
   {
      TP = Bid - takeprofit*pips2points*pips2dbl;
      SL = Bid + stoploss*pips2points*pips2dbl;            
      CLOSEORDER("Buy");
      OPENORDER ("Sell");
   }
//----
   Comment(aheadforup,"  ",aheadbkup,"  ",aheadfordn,"  ",aheadbkdn," cust ",cust,"  ",inita);
   return(0);
  }
//+------------------------------------------------------------------+
//--------------------------------------------------------------------
void CLOSEORDER(string ord)
{
   for (int i=OrdersTotal()-1; i>=0; i--)
   {                                               
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
      {
         if (OrderSymbol()!=Symbol()) continue;
         if (OrderType()==OP_BUY && ord=="Buy")
            OrderClose(OrderTicket(),OrderLots(),Bid,3,CLR_NONE);// Close Buy
         if (OrderType()==OP_SELL && ord=="Sell")
            OrderClose(OrderTicket(),OrderLots(),Ask,3,CLR_NONE);// Close Sell
      }   
   }
}
//--------------------------------------------------------------------
void OPENORDER(string ord)
{
   int error;
   if (ord=="Buy" ) error=OrderSend(Symbol(),OP_BUY, LOT,Ask,2,0,0,"", 1,3,Green);
   if (ord=="Sell") error=OrderSend(Symbol(),OP_SELL,LOT,Bid,2,0,0,"",-1,3,Red);
   if (error==-1) //operation failed
   {  
      ShowERROR(error,0,0);
   }
return;
}                  
//--------------------------------------------------------------------
void ShowERROR(int Ticket,double SL,double TP)
{
   int err=GetLastError();
   switch ( err )
   {                  
      case 1:                                                                               return;
      case 2:   Alert("Error Connection with trade server absent    ",Ticket," ",Symbol());return;
      case 3:   Alert("Error Invalid trade parameters   Ticket ",  Ticket," ",Symbol());return;
      case 130: Alert("Error Invalid stops   Ticket ",             Ticket," ",Symbol());return;
      case 134: Alert("Error Not enough money   ",                 Ticket," ",Symbol());return;
      case 146: Alert("Error Trade context is busy. ",             Ticket," ",Symbol());return;
      case 129: Alert("Error Invalid price ",                      Ticket," ",Symbol());return;
      case 131: Alert("Error Invalid volume ",                     Ticket," ",Symbol());return;
      case 4051:Alert("Error Invalid function parameter value ", Ticket," ",Symbol());return;
      case 4105:Alert("Error No order selected ",                Ticket," ",Symbol());return;
      case 4063:Alert("Error Integer parameter expected ",       Ticket," ",Symbol());return;
      case 4200:Alert("Error    ",            Ticket," ",Symbol());return;
      default:  Alert("Error Object already exists " ,err,"   Ticket ", Ticket," ",Symbol());return;
   }
}
//--------------------------------------------------------------------
//--------------------------------------------------------------------
bool fANYBUY()
{
   bool fstopnbuy, haveopenbuy=false;
   int curbuytype;
   for(int i=0;i<=20;i++)
   {
      fstopnbuy=OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(fstopnbuy==true&&OrderSymbol()==Symbol()&&OrderCloseTime()==0&&OrderType()==OP_BUY)
      {
      haveopenbuy=true;
      break;
      }
   }
return(haveopenbuy);
}   
//--------------------------------------------------------------------
bool fANYSELL()
{
   bool fstopnsell, haveopensell=false;
   int curselltype;
   for(int i=0;i<=20;i++)
   {
      fstopnsell=OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(fstopnsell==true&&OrderSymbol()==Symbol()&&OrderCloseTime()==0&&OrderType()==OP_SELL)
      {
      haveopensell=true;
      break;
      }
   }
return(haveopensell);
}   
//--------------------------------------------------------------------

